'''
Simulation Atomarer Bewegungen
Autor: Maximilian Herzog
Version: 0.5
'''


from turtle import * #Import Turtle (grafische Darstellung der Punkte)
import turtle # Zweiter Import um auch turtle.methode() Aufrufe gewährleisten zu können
from tkinter import * # Grafische Nutzeroberfläche GUI
from functools import partial
from tkinter.messagebox import *
import random # Zufall
import math   # Mathe-Modul für z.B. Kosinussatz
import sys    # System für Recoursion set!
from splash.splashscreen import*
from time import*
import atexit

#Variablen [Symbol,Name,Schmelzpunkt,Siedepunkt]
elements = [["He","Helium",-272,-269], #chemische elemnte
            ["H","Wasserstoff",-259,-253],
            #["Ne","Neon",-249,-246],
            ["N","Stickstoff",-210,-196],
            ["F","Fluor",-220,-188],
            ["O","Sauerstoff",-218,-183],
            #["Kr","Krypton",-157,-153],
            #["Xe","Xenon",-112,-108],
            #["Rn","Radon",-71,-62],
            ["Cl","Chlor",-101,-35],
            ["Br","Brom",-7,59],
            ["H2O","Wasser", 0,100], #Moleküle
            ["C1H4","Methan", -183, -162], #Kohelnwasserstoffe
            ["C2H6","Ethan", -172, -89],
            ["C3H8","Propan", -190, -42],
            ["C4H10","Butan", -135, 0],
            ["C5H12","Pentan", -130, 36],
            ["C6H14","Hexan", -94, 69],
            ["C7H16","Heptan", -90, 98],
            ["C8H18","Oktan", -57, 126],
            ["C9H20","Nonan", -54, 151],
            ["C10H22","Dekan", -30, 174],
            ["C11H24","Undekan", -40, 196],
            ["C12H26","Dodekan", -10, 216],
            ["C16H34","Hexadekan", 18, 280],
            ["C20H42","Eicosan", 36, 344],]




##if sys.version > '3': # Falls Python 3 nicht vorhanden
##    long = int
##
##sys.setrecursionlimit(1000000000)

#Die Variablen sind ganz alleine und müssen noch irgendwo untergebracht werden :( #Waisen
temp = -100
solltemp = -100
run = True
i=-1
scrolling = True

#Simulationsvariablen
ATOMIMG ="atom.gif"
ICON = "logo.ico"
RUNSPEED = 7



# Zeichnen der Atome
def drawatoms(widget,width,height):
 
    # Variableninitializierung
    global a
    global atoms
    global curwidth
    global curheight
    global start_y
    global start_x
    
    if width == "":
        width = 6
    if height == "":
        height = 4
 
    start_y = []
    start_x = []
 
    curwidth = width
    curheight = height

    if(dddv.get() == 0):
        depth = 1
    else:
        depth = 3
    
    atoms = []
    for z in range(depth):
        for w in range(width):
            for h in range(height):
                a = RawTurtle(widget)
##                try:
                a.shape(ATOMIMG)
##                except:
##                    print("ERROR: '" + ATOMIMG + "' konnte nicht gefunden werden, verwende blauen Kreis...")
##                    a.shape("circle")
##                    a.color("blue")
                a.penup()
                a.speed(0)
                a.crispos = ( (w * 20) - width +50 - z*7,(h * 20) - width -130 - z*7 - bgv.get()*42)
                
                a.setx((w * 20) - width +50 - z*7)
                a.sety((h * 20) - width -130 - z*7 - bgv.get()*42)
                atoms.append(a)
 
    random.shuffle(atoms)
 

    for i in atoms:
        start_y.append(i.ycor())
        start_x.append(i.xcor())
 
# Schmelztemperatur
def boil(atoms,degree,reset,temp): #Hier passiert die ganze Magie #Magische Methode
    global solltemp
    ticks = 0
    
    for i in atoms:
 
        if degree != 0:
            if i.heading() != 0: # Zufällige Bewegung
                
                rddreh = random.randint(int(i.heading() - int(degree**1.2) ), int( i.heading() + int(degree**1.2)))

                
            else:
                rddreh = random.randint(0,360)

            if bgv.get() == 0:
                if int(i.xcor()) > 325 or int(i.xcor()) < -170 or int(i.ycor()) > 120 or int(i.ycor()) < -345: #Frame Abprallen
                    i.setheading(i.towards(50, -100))
                else:
                    i.setheading(rddreh)
            else:
                if int(i.xcor()) > 140 or int(i.xcor()) < 14 or int(i.ycor()) > -8 or int(i.ycor()) < -175: #Becherglas abprallen
                    i.setheading(i.towards(20, -100))
                else:
                    i.setheading(rddreh)
                    if degree > 0 and degree < 20: # Flüssiger Aggregatzustand
                        for x in range(5):
                            if not random.randint(0, 20 - int(degree) ) == 0: # Bei erhöter Temperatur, höhere Chance eines Austritts von Atomen
                                if i.ycor() > -190+degree*8:
                                    i.goto(i.xcor(), i.ycor()-1) # Genialer Wasserspiegel



    #### Code von Maxi -- Bitte nicht löschen ;I ###        ich würde das weglassen, damit es nicht so stark ruckelt, aber ich sehe, dass es (fast) funktioniert

        adhense = True
##        
##        if dddv.get() == 0:
##            #Keine Überlagerung in 2D ansicht    
##            for c in atoms:
##                if c != i:
##                    if i.distance(c) < 5:
##
##                        ####  ~(._.~) THE MAGIC (~._.)~ ###
##                        
##                        i.setheading(i.heading()+180)
##                        c.setheading(c.heading()+180)
##                        adhense = False
##
##                        while i.distance(c) < 5:
##                            c.goto(c.xcor() + (c.xcor() - i.xcor())*(degree*0.1),
##                                   c.ycor() + (c.ycor() - i.ycor())*(degree*0.1))
##                            
##                            i.goto(i.xcor() + (i.xcor() - c.xcor())*(degree*0.1),
##                                   c.ycor() + (i.ycor() - c.ycor())*(degree*0.1))


                        
        if reset:
            i.fd(degree)
            i.goto( start_x[ticks] + random.randint(int(-degree/2), int(degree/2)),  start_y[ticks] + random.randint(int(-degree/2),int(degree/2))) # RESET
##            i.sety(start_y[ticks])
##            i.setx(start_x[ticks])
        else:

            if adhense:
                if degree > 0 and degree < 20: #Flüssiger Aggregatzustand #Abgehoben
                    #i.setheading((i.heading()*(i.distance(0, 0)/10)+i.towards(50, -100))/(i.distance(0, 0)/10)+1)

                    if random.randint(0,int((temp-smeltpoint)*10)) < 10:
                        if i.distance(i.crispos[0]+33,i.crispos[1]) > (temp-smeltpoint+10)/5 + 30 and temp < smeltpoint +(solltemp-temp)/25+4 or i.distance(i.crispos[0],i.crispos[1]) > (temp-smeltpoint+10)/5 + 30: # Drang zur Mitte
                            i.setheading(i.towards(i.crispos))          #f(x) = (x / 100)^0.05 - 0.005x
                    else:
                        if i.distance(i.crispos[0],i.crispos[1]) > (temp-smeltpoint+10)/5 + 30 and temp < smeltpoint +(solltemp-temp)/25+4 or i.distance(i.crispos[0],i.crispos[1]) > (temp-smeltpoint+10)/5 + 30: # Drang zur Mitte
                            i.setheading(i.towards(i.crispos))          #f(x) = (x / 100)^0.05 - 0.005x


                

                    
                    #print(i.distance(i.crispos[0],(i.crispos[1]-1)/2))
                        #print((solltemp-temp)/25+4)

                    
##                for a in atoms:
##                    if(i != a):
##                        if i.distance(a) > 50 and i.distance(a) < 100:  #bereich in dem angezogen werden soll
##
##
##                                                                                    #Abstoßen bei 50      funktioniert überhauptnicht!!
##                            i.goto(i.xcor() - (a.xcor() - i.xcor())/i.distance(a), i.ycor() + (a.ycor() - i.ycor())/i.distance(a))
##                            break
##                        elif i.distance(a) < 50:            #bereich in dem abgestoßen werden soll
##                            
##                            x = (i.xcor()-a.xcor())  /  10  #abprall strecke x und y
##                            y = (i.ycor()-a.ycor())  /  10  # duch 10 weil sonst zu starke sprünge
##                            #print(x,y)                     # schient insgesamt nur bei einem Atom berechnet zu werden.
##                            i.goto(i.xcor()+x,i.ycor()+y)




                
                #i.goto(i.xcor() + (50 - i.xcor())/i.distance(a), i.ycor() - (0 - i.ycor())/i.distance(a))
                #i.goto(i.xcor() - abs((i.xcor() - 50)/i.distance(50,-100)), i.ycor() - abs((i.ycor() +100)/i.distance(50,-100)))

            """
Abstoßen ist für uns praktisch unmöglich nicht möglich.
Ich habe eine Methode geschrieben(abstos()), die solange läuft bis es keine Überlappungen der Atome mehr gibt. Da hat man 0.00005 fps!
Das Problem ist, dass, wenn ein Atom abgestoßen wird, fliegt es in ein anderes rein. Dadurch gibt es ununterbrochen irgendwelche Überlappungen.

        """
##                for a in atoms:
##                    if(i != a):
##                        if i.distance(a) < 19:  #Abstoßen bei 3
##                            i.setheading(i.heading()+180)
##                            #i.color("red");a.color("orange")
##                            #i.shape("circle");a.shape("circle")
##                            #cv.update()
##                            #input(i.distance(a))
##                            i.shape(ATOMIMG);a.shape(ATOMIMG)
##                            i.fd(1)
##                            
##                            a.setheading(a.heading()-180)
##                            a.fd(1)


    

        
        
        


        

        i.fd(degree/3)
        #print(degree)

            
            
         
        ticks += 1
        cv.update()
 
def abstos():
    l = [0]
    while len(l) == 0:              # solange bis keine Überlagerung mehr
        l = []
        for a1 in atoms:        # systematisch alle Atome abklappern
            for a2 in atoms:

                if a1.distance(a2) < 6:    # Abstoßen
                    a1.left(180);a2.right(180)
                    a1.fd(1);a2.fd(1)
                
                if a1.distance(a2) < 4:    # immernoch überlappend?                   
                    l.append((a1,a2))       # dann rein damit
            print(len(l))    
 
# Funktion zum neuzeichnen der Atome
def redraw(atoms):
     
    for a in atoms:
        for w in range(curwidth):

                a.setx(w * 20)
                a.sety(h * 20)
 
def react(temp, atoms):
    global sd
    if temp >= smeltpoint-273 and temp <= smeltpoint: #Vor Schmelz
        d = (temp + 273)/40
        boil(atoms,d, True,temp)
    elif temp > smeltpoint and temp <= boilpoint: #Nach Schmelz
        d = 10 + (temp + 273)/70
        boil(atoms,d, False,temp)
        if airv.get() == 1 and bgv.get() == 1:
            cv.bgpic("background/bg_glass+air.gif")
    elif temp > boilpoint:              #Nach Siede
        d = 20
        boil(atoms, d, False,temp)
        if airv.get() == 1 and bgv.get() == 1:
            cv.bgpic("background/bg_glass+air_agg-gas.gif")
    elif temp < smeltpoint-270:         #bewegungslos
        d = 0
        boil(atoms, 0, True,temp)

     #react(temp, atoms) #Rekursion
        
    #abstos()
    cv.update()
    
    sd.config(text="Stoff: " + aname[0] + " / " + aname[1] +  " | "+str(round(d,2)), font=100,bg="white")


def interface():
 
    # Variableninitializierung
    global root
    global tm
    global cv
    global s
    global sd
 
    root = Toplevel()
    root.title("Atomare Bewegungen der Aggregatzustände              \u00A9 OFactory")
    root.geometry("655x579")
    try:
        root.iconbitmap(ICON)
    except:
        print("ERROR: '" + ICON + "' konnte nicht gefunden werden, verwende Tkinter Logo...")
    root.protocol("WM_DELETE_WINDOW", root.destroy)
    
    root.config(background="#FFFFFF")
    root.resizable(0,0)
    #Scala zum Regeln
    
    s = Scale(root, label="°C      ", orient="vertical",length=480,from_=250,to=-273,background="#FFFFFF",tickinterval=50,border=0)
    s.bind("<Button-1>", stopscroll)
    s.pack(side="left",fill="y",pady=20)
    s.set(-100)
 
    sd = Label(root,text="Stoff: Stoffname / Formel", font=100,bg="white")
    sd.pack(side="top")
    
    f = Frame(root,bg="white")
    
    g_frame=Frame(f, width=650, height=900, bg="white")
 
    turtle._Screen._root = g_frame
    turtle._Screen._canvas = turtle.Canvas(root,relief=SUNKEN) #Kompliziertes Zeug um das fenster zu erstellen! nicht berühren
    cv = _s_ = turtle.Screen()
 
    turtle.TurtleScreen.__init__(_s_, _s_._canvas)
    scanvas = _s_._canvas
 
    turtle.RawTurtle.screens = [_s_]
 
    scanvas.pack(fill=BOTH, expand=2)
    g_frame.pack(side="right")
    scanvas.config(border=2, relief="groove")
    
    bf = Frame(root,bg="white")             
    cv.tm = Label(bf,text="Stofftemperatur: 0 °C | 0 K", font=100,bg="white")
    cv.tm.pack(side="left")
    cv.b = Button(bf,text="II",command=togglerun,font=("Helvetica", 20, "bold"),relief="flat", border=0,fg='#303030')
    cv.b.pack(side="right",padx=30)

    cv.onclick(click)
    
    print("test2 ----------")
    print("dddv:",dddv.get())
    print("airv: ",airv.get())
    print("bgv:",bgv.get())
    
    
    if airv.get()  == 1:
        cv.bgpic("background/bg_air.gif")
    if dddv.get() == 1:
        cv.bgpic("background/bg_3d.gif")
    if bgv.get() == 1:
        cv.bgpic("background/bg_glass.gif")
    if airv.get() == 1 and dddv.get() == 1:
        cv.bgpic("background/bg_3d+air.gif")
    if airv.get() == 1 and bgv.get() == 1:
        cv.bgpic("background/bg_glass+air.gif")
    if airv.get() == 1 and dddv.get() == 1 and bgv.get() == 1:
        cv.bgpic("background/bg_3d+glass+air.gif")
    if dddv.get() == 1 and bgv.get() == 1 and airv.get() == 0:
        cv.bgpic("background/bg_3d+glass.gif")
    
    bf.pack()
    root.iconify()
    root.deiconify()
    try:
        cv = Screen()
        cv.register_shape("atom.gif")
        #cv.bgcolor("red")
        cv.tracer(False)

    except:
        print("ERROR: Frame Objekt konnte kein Screen Objekt hinzugefügt werden!")

def click(x, y):
    print(str(x) + "," + str(y))

    
def togglerun():
    global run,cv
    if run:
        run = False
        cv.b.config(text="\u25B6")
    else:
        run = True
        cv.b.config(text="II")
        recursive()
def hexa(n):
    h = hex(n)[2:]
    if len(h) < 2:
        return '0'+str(h)
    return str(h)
def hexcolor(r,g,b):
    return '#'+hexa(r)+hexa(g)+hexa(b)

def stopscroll(dummy):
    global scrolling
    print("stop it!")
    scrolling = False

    
def recursive():
    global temp,i,run,solltemp
    if i < 200 and scrolling:
        i+=1
        s.set(-100 + i)
    

    solltemp = s.get()

    temp = (solltemp+temp*350)/351
    
    #Solltemperatur ordentlich printen!
    if solltemp < temp:
        if 200-(temp-solltemp) > 0:
            s.config(troughcolor=hexcolor(200-int(temp-solltemp), 200-int(temp-solltemp), 255))
        else:
            s.config(troughcolor=hexcolor(0, 0, 255))
    elif solltemp > temp:
        if 200-(solltemp-temp) > 0:
            s.config(troughcolor=hexcolor(255, 200-int(solltemp-temp), 0))
        else:
            s.config(troughcolor=hexcolor(255, 0, 0))
    else:
        s.config(troughcolor=hexcolor(200, 200, 200))

    cv.tm.config(text="Stofftemperatur: " + str(round(temp,1))+" °C" + " | " + str(round(temp+273.15,1))+" K")

    #Stoffart ordentlich printen
    #sd.config(text="Stoff: " + str(aname[1]) + " / " + str(aname[0]))
    
    react(temp,atoms)
    cv.update()
    if run:
        root.after(RUNSPEED, lambda: recursive())      #Rekursion nach 9 millis

 
def get_atom(inp):
    
    global boilpoint
    global smeltpoint
    global aname
    
    if inp == "":
        inp = "Wasser"
    for name in elements:
        if inp == name[0] or inp == name[1]:
            print(name)
            aname = name
            boilpoint = name[3]
            smeltpoint = name[2]
            return name[2],name[3]

def confirm():
    ##
    global atup
    print("test1 ----------")
    print("dddv:",dddv.get())
    print("airv: ",airv.get())
    print("bgv:",bgv.get())
    sleep(2)
    try:
        #Breite
        if wentry.get() == "":
            inpwidth = 3
        else:
            inpwidth = int(wentry.get())
        #Höhe
        if hentry.get() == "":
            inpheight = 3
        else:
            inpheight = int(hentry.get())
 
    except:
        messagebox.showinfo("Fehler", "Es muss eine natürliche Zahl eingegeben werden!")
        return
 
    atup = get_atom(kentry.get())
    if(atup == None):
        messagebox.showinfo("Fehler", "Dieses Atom/Molekül gibt es nicht! Bitte tragen sie etwas anderes ein!")
        return
    
    print(atup)
       

    startroot.withdraw()
    interface()
    drawatoms(cv, inpwidth, inpheight)
    try:
        recursive()
    except TclError:
        print("Programm schließen ...")
    #except:
    #    messagebox.showinfo("Fehler", "Tut uns leid! Es ist ein Fehler aufgetreten. Bitte kontaktieren Sie Maximilian Herzog oder Hans Olischläger.")
    

    return
 
def close(widget):
    widget.destroy()

 
def closecall():
    print("Programm schließen ...")
    close(startroot)
    return

def dddswitch():
    print("switch")
    if dddv.get() == 1:
        tentry.grid(column=1,row=4,sticky=E)
        teight.grid(column=0,row=4,sticky=W)
        startroot.geometry("550x430")
    else:
        tentry.grid_forget()
        teight.grid_forget()
        startroot.geometry("550x390")

    

def startinterface():
    # höflich verabschieden #Manieren #unhöflicher Bengel!
    atexit.register(closecall)
    
    
    # Varaibleninitializierung # Zitat Hans "Scheiß globales Zeug!"
    global startroot
    global header
    global wentry
    global hentry
    global kentry
    global dddv
    global airv
    global bgv
    global tentry
    global teight
 
    startroot = Toplevel()
    startroot.title("Atomare Bewegungen der Aggregatzustände")
    try:
        startroot.iconbitmap(ICON)
    except:
        print("ERROR: '" + ICON + "' konnte nicht gefunden werden, verwende Tkinter Logo...")
    startroot.geometry("550x430")
    startroot.resizable(0,0)
 
    header = Label(startroot, text="Atomsimulation", font=("Helvetica", 35))
    header.grid(column=0,row=0)
 
    #Art Label und Entry
    kind = Label(startroot, text="Atom/Molekül:" , font=("Helvetica",20))
    kind.grid(column=0,row=1,sticky=W)
    kentry = Entry(startroot, font=("Helvetica",20), width=15)
    kentry.insert("end","Wasser")
    kentry.grid(column=1,row=1,sticky=E)
 
    #Breite Label und Entry
    breite = Label(startroot, text="Breite:" , font=("Helvetica",20))
    breite.grid(column=0,row=2,sticky=W)
    wentry = Entry(startroot, font=("Helvetica",20), width=15)
    wentry.insert("end","4")
    wentry.grid(column=1,row=2,sticky=E)
 
    #Höhe Label und Entry
    height = Label(startroot, text="Höhe:" , font=("Helvetica",20))
    height.grid(column=0,row=3,sticky=W)
    hentry = Entry(startroot, font=("Helvetica",20), width=15)
    hentry.insert("end","4")
    hentry.grid(column=1,row=3,sticky=E)

    #Teife Label und Entry
    teight = Label(startroot, text="Tiefe(3D):" , font=("Helvetica",20))
    teight.grid(column=0,row=4,sticky=W)
    tentry = Entry(startroot, font=("Helvetica",20), width=15)
    tentry.insert("end","3")
    tentry.grid(column=1,row=4,sticky=E)

    #Extra eintsellungen
    extra = Label(startroot, text="——Erweiterte Einstellungen—————————————————————" , font=("Helvetica",12))
    extra.grid(column=0,row=5,sticky=W,columnspan=2,pady=10)
    
    #3d-Ansicht Label und Text
    ddd = Label(startroot, text="3D-Ansicht:" , font=("Helvetica",20))
    ddd.grid(column=0,row=6,sticky=W)
    dddv = IntVar()
    dddcheck = Checkbutton(startroot, font=("Helvetica",12), var=dddv, command=dddswitch)
    dddcheck.grid(column=1,row=6,sticky=E)
    dddswitch()
    
    #Luftmoleküle Label und Text
    air = Label(startroot, text="Luftmoleküle:" , font=("Helvetica",20))
    air.grid(column=0,row=7,sticky=W)
    airv = IntVar()
    aircheck = Checkbutton(startroot, var=airv)
    aircheck.grid(column=1,row=7,sticky=E)

    #Becherglas Label und Text
    bg = Label(startroot, text="Becherglas:" , font=("Helvetica",20))
    bg.grid(column=0,row=8,sticky=W)
    bgv = IntVar()
    bgcheck = Checkbutton(startroot, var=bgv)
    bgcheck.grid(column=1,row=8,sticky=E)

 
    #Bestätigen Knopf
    confirmb = Button(startroot, text="Bestätigen",font=("Helvetica",20), command=confirm)
    confirmb.grid(column=1,row=9,sticky=E)
 
    #Beenden Knopf
    closeb = Button(startroot, text="Beenden",font=("Helvetica",20), command=closecall)
    closeb.grid(column=0,row=9,sticky=W)
    startroot.mainloop()

def splash():
    r=Tk()           
    splash = SplashScreen(r,width=0.305,height=0.32)
    splash.config(bg="white",relief="raised")
    logo = PhotoImage(file="splash/splash.gif")
    picwidget = Label(splash, 
      compound = "center", background="white",
      image=logo)
    picwidget.pack()

    g_frame=Frame(splash)
    turtle._Screen._root = splash
    turtle._Screen._canvas = turtle.Canvas(splash,relief="flat")
    screen = _s_ = turtle.Screen()
    #####
    turtle.TurtleScreen.__init__(_s_, _s_._canvas)
    #####
    scanvas = _s_._canvas
    #xturtle.RawTurtle.canvases = [self.scanvas]
    turtle.RawTurtle.screens = [_s_]
    ##############################
    scanvas.pack(side=BOTTOM, fill=BOTH, expand=1)
    s = Screen()
    s.setup(200,5)
    t=Turtle()
    t.hideturtle()
    t.color("blue")
    t.pensize(20)
    t.up()
    t.speed(1)
    t.goto(-170,-10)
    t.showturtle()
    t.down()
    t.forward(350)
    sleep(1)
    r.withdraw()

splash()#Produkt Placement in your face! #Frontsplashen 
 
startinterface() # StartGUI dem User ins Gesicht prompten #Wie unfreundlich :( 
   
mainloop() # Mainloop für Windoof
